'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recharts = require('recharts');

var _lodashFindIndex = require('lodash/findIndex');

var _lodashFindIndex2 = _interopRequireDefault(_lodashFindIndex);

var COLORS = ['#0088FE', '#00C49F', '#FFBB28', '#FF8042'];

var renderActiveShape = function renderActiveShape(props) {
  var RADIAN = Math.PI / 180;
  var cx = props.cx;
  var cy = props.cy;
  var midAngle = props.midAngle;
  var innerRadius = props.innerRadius;
  var outerRadius = props.outerRadius;
  var startAngle = props.startAngle;
  var endAngle = props.endAngle;
  var fill = props.fill;
  var payload = props.payload;
  var value = props.value;

  var sin = Math.sin(-RADIAN * midAngle);
  var cos = Math.cos(-RADIAN * midAngle);

  var activeCx = cx + cos * 0;
  var activeCy = cy + sin * 0;

  var sx = cx + (outerRadius + 3) * cos;
  var sy = cy + (outerRadius + 3) * sin;
  var mx = cx + (outerRadius + 12) * cos; // 20
  var my = cy + (outerRadius + 12) * sin;
  // const ex = mx + (cos >= 0 ? 1 : -1) * 10; // Distance of outer line
  // const ey = my;
  var ex = mx; // Distance of outer line
  var ey = my + (sin >= 0 ? 1 : -1) * 7;
  // const textAnchor = cos >= 0 ? 'start' : 'end';
  var textAnchor = "middle";

  var dist = 8;
  var textStyle = {
    fontSize: 12
  };

  return _react2['default'].createElement(
    'g',
    null,
    _react2['default'].createElement(_recharts.Sector, {
      cx: activeCx,
      cy: activeCy,
      innerRadius: innerRadius,
      outerRadius: outerRadius,
      startAngle: startAngle,
      endAngle: endAngle,
      fill: fill
    }),
    _react2['default'].createElement(_recharts.Sector, {
      cx: activeCx,
      cy: activeCy,
      innerRadius: outerRadius + 3,
      outerRadius: outerRadius + 7,
      startAngle: startAngle,
      endAngle: endAngle,
      fill: fill
    }),
    _react2['default'].createElement('path', { d: 'M' + sx + ',' + sy + 'L' + mx + ',' + my + 'L' + ex + ',' + ey, stroke: fill, fill: 'none' }),
    _react2['default'].createElement('circle', { cx: ex, cy: ey, r: 2, fill: fill, stroke: 'none' }),
    _react2['default'].createElement(
      'text',
      { x: ex, y: ey + (sin >= 0 ? 1 : -1) * dist, textAnchor: textAnchor, fill: '#333', style: textStyle },
      '' + payload.key
    )
  );
};

var PieFilterList = (function (_React$Component) {
  _inherits(PieFilterList, _React$Component);

  function PieFilterList(props) {
    _classCallCheck(this, PieFilterList);

    _get(Object.getPrototypeOf(PieFilterList.prototype), 'constructor', this).call(this, props);

    this.state = {
      hoveredIndex: -1
    };

    // this.onPieEnter = this.onPieEnter.bind(this)
    // this.onPieLeave = this.onPieLeave.bind(this)
    this.onSelect = this.onSelect.bind(this);
  }

  // handleChange(selectedOptions = []) {
  //   this.props.setItems(selectedOptions.map(el => el.value))
  // }

  _createClass(PieFilterList, [{
    key: 'onPieEnter',
    value: function onPieEnter(data, hoveredIndex) {
      this.setState({ hoveredIndex: hoveredIndex });
    }
  }, {
    key: 'onPieLeave',
    value: function onPieLeave(data, hoveredIndex) {
      this.setState({ hoveredIndex: -1 });
    }
  }, {
    key: 'onSelect',
    value: function onSelect(data, index) {
      this.props.toggleItem(data.key);
    }
  }, {
    key: 'getSelectedIndex',
    value: function getSelectedIndex() {
      var _props = this.props;
      var items = _props.items;
      var _props$selectedItems = _props.selectedItems;
      var selectedItems = _props$selectedItems === undefined ? [] : _props$selectedItems;

      if (selectedItems.length == 0) return [this.state.hoveredIndex];
      var selected = selectedItems.map(function (key) {
        return (0, _lodashFindIndex2['default'])(items, { key: key });
      });
      if (this.state.hoveredIndex >= 0) {
        selected.push(this.state.hoveredIndex);
      }
      return selected;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var placeholder = _props2.placeholder;
      var _props2$clearable = _props2.clearable;
      var clearable = _props2$clearable === undefined ? true : _props2$clearable;
      var items = _props2.items;
      var _props2$selectedItems = _props2.selectedItems;
      var selectedItems = _props2$selectedItems === undefined ? [] : _props2$selectedItems;
      var disabled = _props2.disabled;
      var showCount = _props2.showCount;
      var setItems = _props2.setItems;

      // onMouseEnter={this.onPieEnter}
      // onMouseLeave={this.onPieLeave}
      return _react2['default'].createElement(
        _recharts.PieChart,
        { width: 250, height: 165,
          onClick: this.onSelect },
        _react2['default'].createElement(
          _recharts.Pie,
          { startAngle: 180, endAngle: 0, fill: '#8884d8',
            cx: 125, cy: 125, outerRadius: 85,
            activeShape: renderActiveShape,
            activeIndex: this.getSelectedIndex(),
            isAnimationActive: false,
            nameKey: 'key', valueKey: 'doc_count',
            data: items },
          items.map(function (entry, index) {
            return _react2['default'].createElement(_recharts.Cell, { fill: COLORS[index % COLORS.length] });
          })
        ),
        _react2['default'].createElement(_recharts.Legend, null)
      );
    }
  }]);

  return PieFilterList;
})(_react2['default'].Component);

exports.PieFilterList = PieFilterList;
/*<text x={activeCx} y={activeCy} dy={8} textAnchor="middle" fill={fill}>{payload.name}</text>*/ /*<text x={ex} y={ey + (sin >= 0 ? 1 : -1) * dist} textAnchor={textAnchor} fill="#999" style={textStyle}>
                                                                                                  {`(${payload.doc_count})`}
                                                                                                 </text>*/